=== 3rdparty/flac/examples/cpp/encode/file/CMakeLists.txt ===
add_executable(encode_file_cxx main.cpp)
target_link_libraries(encode_file_cxx FLAC++)
