=== debian/changelog ===
mame (0.280+dfsg.1-0.1~mx25+1) mx; urgency=medium

  * New upstream release.
  * Disable patches for non-MX supported arches.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 30 Aug 2025 21:25:16 -0700
